<?php 

if ( version_compare(PHP_VERSION,"5.0.0","<") ) {
	die("ABBRUCH: es wird PHP5 oder hoeher benoetigt.\n"
		." -> http://de.php.net/downloads.php\n");
}

define("OGDB_REMOTE_DATA_FILE","http://fa-technik.adfc.de/code/opengeodb/PLZ.tab");
define("OGDB_LOCAL_DATA_FILE","./PLZ.tab");

function ogdbDistance($origin,$destination) {
	if ( !is_file(OGDB_LOCAL_DATA_FILE) || filesize(OGDB_LOCAL_DATA_FILE)==0 ) {
		$fileData = file_get_contents(OGDB_REMOTE_DATA_FILE);
		if ( $fileData == FALSE ) {
			die("ABBRUCH: konnte Daten nicht laden (".OGDB_REMOTE_DATA_FILE.")\n");
		}
		if ( file_put_contents(OGDB_LOCAL_DATA_FILE,$fileData) == FALSE ) {
			die("ABBRUCH: konnte Daten nicht speichern (".OGDB_LOCAL_DATA_FILE.")\n");
		}
		unset($fileData);
	}
	$fileData = @file_get_contents(OGDB_LOCAL_DATA_FILE);
	if ( $fileData == FALSE ) {
		die("ABBRUCH: konnte Daten nicht laden (".OGDB_LOCAL_DATA_FILE.")\n");
	}
	$fileData = explode("\n",$fileData);
	for ( $i=1; $i < count($fileData); $i++ ) {
		$fileRow = explode("\t",$fileData[$i]);
		if ( $origin == $fileRow[1] ) {
			$origin_lon = deg2rad($fileRow[2]);
			$origin_lat = deg2rad($fileRow[3]);
		}
		if ( $destination == $fileRow[1] ) {
			$destination_lon = deg2rad($fileRow[2]);
			$destination_lat = deg2rad($fileRow[3]);
		}
	}
	return acos(sin($destination_lat)*sin($origin_lat)+cos($destination_lat)*cos($origin_lat)*cos($destination_lon - $origin_lon))*6375;
}

